import { PublisherSchema } from ".";
import { DocumentNode } from "graphql";
import { EventBusPlugin, EventBusSubscriberCb } from "./VanillaEventBus";
export interface SubscriberConfig {
    queries: DocumentNode;
    schema: PublisherSchema;
    cb: (bus: EventBus) => EventBusSubscriberCb;
    isDarkRelease?: boolean;
}
export interface PublisherConfig {
    schema: PublisherSchema;
}
export interface EventBusConfig {
    publisher?: PublisherConfig;
    subscriber?: SubscriberConfig;
    serviceName: string;
    plugins?: EventBusPlugin[];
}
export declare type Publish = (props: {
    topicName: string;
    data: {};
}, metadata: {
    [header: string]: string | string[] | undefined;
}) => Promise<unknown>;
export declare abstract class EventBus {
    abstract init(): Promise<void>;
    abstract publish: Publish;
    abstract closeConsumer(): Promise<unknown>;
    abstract closePublisher(): Promise<unknown>;
}
